-- These demos use a modified copy of the demo database AdventureWorksDW2008.
-- The only modification is the addition of a new table: FactResellerSalesXL.
-- The schema of this table is exactly identical to FactResellerSales,
-- but a huge amount of extra data has been added to get more than a million rows.

USE AdventureWorksDW2012XL
go

SELECT COUNT(*) FROM dbo.FactResellerSales;
--      60,855 rows

SELECT COUNT(*) FROM dbo.FactResellerSalesXL;
-- 107,306,348 rows

-- Note that, apart from the extra rows, the two tables are almost identical.
-- The only differences are:
-- 1: FactResellerSalesXL is partitioned by date;
-- 2: Because of that, the clustered index had to be changed and the primary key removed;
-- 3: And, obviously, there is an additional columnstore index.
go
