USE AdventureWorksDW2012XL;
go


SELECT     OBJECT_NAME (p.object_id)            AS "Table name",
           COL_NAME (p.object_id, ic.column_id) AS "Column name",
		   s.column_id,
           p.partition_number,
           s.segment_id,
           s.min_data_id,
           s.max_data_id,
           s.on_disk_size
FROM       sys.column_store_segments            AS  s
INNER JOIN sys.partitions                       AS  p
      ON   p.partition_id                        =  s.partition_id
LEFT  JOIN sys.index_columns                    AS  ic
      ON   ic.object_id                          =  p.object_id 
      AND  ic.index_id                           =  p.index_id 
      AND  ic.index_column_id                    =  s.column_id
WHERE      OBJECT_NAME (p.object_id)             = 'FactResellerSalesXL'      -- Filter on table
--AND        COL_NAME (p.object_id, ic.column_id)  = 'PromotionKey'             -- Filter on column
ORDER BY  "Table name",
		   s.column_id,
           p.partition_number,
           s.segment_id;
go
