USE SevenSteps;
go

/* ============================================= */
/* Problem: How many orders ship on Feb 6, 2011? */
/* ============================================= */

-- We filter on ShipDateChar, so let's create that index
CREATE INDEX ix_SalesOrderHeader_ShipDateChar
       ON    dbo.SalesOrderHeader(ShipDateChar);
GO


DECLARE @StartTime datetime;
SET @StartTime = CURRENT_TIMESTAMP;

DECLARE @Date datetime;
SET @Date = '20110206'

SELECT COUNT(*)
FROM   dbo.SalesOrderHeader
WHERE  ShipDateChar = @Date;

SELECT DATEDIFF(ms, @StartTime, CURRENT_TIMESTAMP);
go


/* Without the conversion, a far more efficient seek can be used */

DECLARE @StartTime datetime;
SET @StartTime = CURRENT_TIMESTAMP;

DECLARE @Date char(8);      -- This data type matches the table
SET @Date = '20110206'

SELECT COUNT(*)
FROM   dbo.SalesOrderHeader
WHERE  ShipDateChar = @Date;

SELECT DATEDIFF(ms, @StartTime, CURRENT_TIMESTAMP);
go
